unit Unit1;

{$mode objfpc}{$H+}

interface

uses
 Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ExtCtrls,
 StdCtrls;

type

 { TForm1 }

 TForm1 = class(TForm)
  Button1: TButton;
  Dclk: TCheckBox;
  Label1: TLabel;
  Label2: TLabel;
  Label3: TLabel;
  Timer1: TTimer;
  procedure Button1Click(Sender: TObject);
  procedure DclkChange(Sender: TObject);
  procedure FormCreate(Sender: TObject);
  procedure Timer1Timer(Sender: TObject);
 private
  { private declarations }
 public
  procedure label_update;
  { public declarations }
 end;

var
 Form1: TForm1;
 flag:integer;


implementation

{$R *.lfm}

{ TForm1 }

procedure Tform1.label_update;
begin
 case dclk.Checked of
  true :label1.caption:='true';
  false:label1.caption:='false';
 end;
 label2.caption:='';
 label3.caption:='';
end;

// Init
procedure TForm1.FormCreate(Sender: TObject);
begin
 flag:=0;
 label_update;
 timer1.Interval:=5000; // 5 sec Timeout
 timer1.Enabled:=false;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
 // Zustand des Eingangs ausgeben
 label_update;

 // Timeout-Timer aktivieren
 timer1.enabled := true;

 // Wenn Eingang auf false , dann
 While Dclk.Checked = false do
  begin
    if Flag = 1
     then
      begin
       label2.caption := 'Timeout '+
                          inttostr(timer1.Interval div 1000)+
                          ' sec , Timer hat zugeschlagen , Flag=1 , Kein Signanl am Eingang!';
       flag:=0;
       break;
      end;

    label2.caption := 'Running , warte auf ein Signal am Eingang innerhalb von '+
                       inttostr(timer1.Interval div 1000)+
                       ' sec';

    // Aktuelle Zeit ausgeben , damit man sieht , das was passiert
    label3.caption:=timetostr(now);
    application.ProcessMessages; // diese ist entscheidend, damit der Timer funzt und die ganze App ansonsten auch noch reagiert !!
  end;

 timer1.enabled := false; // Timer wieder aus
end;

// Bei Flankenwechsel am Eingang simuliern
procedure TForm1.DclkChange(Sender: TObject);
begin
 button1.Click;
end;

// Timeout
procedure TForm1.Timer1Timer(Sender: TObject);
begin
 flag:=1;
end;

end.

